#version 300 es
precision mediump float;

uniform vec2 u_display_size;
uniform vec3 u_colorA;
uniform vec3 u_colorB;
uniform vec3 u_colorC;
uniform float u_time;

in vec2 v_uv;  // From vertex shader
out vec4 fragColor;

void main() {
    vec2 uv = v_uv;

    // Calculate the distance from the center
    float distFromCenter = distance(uv, vec2(0.5, 0.5));

    // Time-based interpolation between colors
    float blendFactorA = sin(u_time) * 0.5 + 0.5;  // Oscillates between 0 and 1
    float blendFactorB = cos(u_time) * 0.5 + 0.5;  // Another oscillation between 0 and 1
    vec3 color = mix(u_colorA, u_colorB, blendFactorA);
    color = mix(color, u_colorC, blendFactorB);

    // Aura pulse effect based on distance
    float intensity = 1.0 - smoothstep(0.2, 0.5, distFromCenter);

    fragColor = vec4(color * intensity, 1.0);
}
